// m3p01.cc - nombres en diferents bases

#include <stdio.h>
#include <string.h>
#include <stdlib.h>


int convertir(char *numero, int base);
int DeCaracterAnombre(char d);

int main()
{
     
   system("clear");
   printf(" '331' en octal a decimal és:       %d\n",convertir("331", 8));
   printf(" 'D9'  en hexadecimal a decimal és: %d\n",convertir("D9", 16));
   printf(" '10110' en binari a decimal és:    %d\n",convertir("11011001", 2));
   
   return 0;
}

int convertir(char *numero, int base)
{
   int Multiplicador = 1,Digitn,Valor = 0;
   
   Digitn = strlen(numero)-1;

   while(Digitn >= 0)
   {
      Valor += DeCaracterAnombre(numero[Digitn])*Multiplicador;
      Multiplicador *= base;
      Digitn--;
   }
   return Valor;
}


int DeCaracterAnombre(char d)
{
    if(d >= '0' && d <= '9') return d-'0';
    if(d >= 'a' && d <= 'f') return 10+d-'a';
    if(d >= 'A' && d <= 'F') return 10+d-'A';
    return -1; // aquest caràcter no és vàlid
}
