//m2pa2.cpp: Angle de dos vectors

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include <stdio.h>
#include <math.h>

double deg(double); //converteix radians a graus
double modul(double, double); //calcula el mdul d'un vector
double pro_esc(double, double, double, double); //producte
                                                //escalar
double angle(double,double,double,double); //angle

void main(){
    double ux,uy;
    double vx,vy;

    printf("introduu les coordenades d'u:\n");
    scanf("%lf %lf",&ux,&uy);
    
	printf("introduu les coordenades de v:\n");
    scanf("%lf %lf",&vx,&vy);
    
	printf("l'angle que formen s %.2lf graus\n",
    angle(ux,uy,vx,vy));
}



double angle(double ux,double uy,double vx,double vy){
    double cosinus;

    cosinus = pro_esc(ux,uy,vx,vy)/modul(ux,uy)/modul(vx,vy);
    return deg(acos(cosinus));
}



double deg(double ang){
    const double PI=3.14159265358979;

    return ang*180/PI;
}



double modul(double x, double y){

    return sqrt(pro_esc(x,y,x,y));
}



double pro_esc(double ux, double uy, double vx, double vy){

    return ux*vx+uy*vy;
}
