//m4p06.cpp: Simulaci de dos daus

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include<stdio.h>
#include<stdlib.h>
#include<time.h>

int dau(void);

void main(){
    int n=100000; //nombre de simulacions
    int ct;
    int freq[13]={0}; //acumular les freqncies
    int temp;

    srand( (unsigned)time( NULL ) );

    for(ct=0;ct<n;ct++){
        temp=dau()+dau();
        freq[temp]++;
    }

    for(ct=2;ct<=12;ct++){
       printf("punt. %d, %d vegades, freq relativa:  %.4f\n",
       ct,freq[ct],float(freq[ct])/n);
    }
}



int dau(){
    return rand()*6/32768+1;
}

