//m4p08.cpp: ABSORCI DE NEUTRONS

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#define N_NEUTRONS 100000
#include <stdio.h>
#include <stdlib.h>

void main(){

    int n=4;       //nombre de capes de la paret de plom
    int energia=10;//energia cintica inicial dels neutrons
                   //mesurat en nombre de xocs mxim.
    int dau;       //nombre aleatori entre 0 i 3.
    int capa;      //nivell actual del neutr.
    int trav=0;    //nombre de neutrons que travessen.
    int ref=0;     //nombre de neutrons que sn reflectits.
    int abs=0;     //nombre de neutrons absorbits
    int neutrons=N_NEUTRONS; //nombre de neutrons.


    while(neutrons--){
        capa=0;
        energia=10;
        while(energia--){
            dau=rand()*4/32768;
            switch (dau){
            case 0:
               capa--;
               break;
            case 3:
               capa++;
               break;
            }
            if (capa==n) {
                 trav++;
                 break;
            }
            if (capa<0) {
                 ref++;
                 break;
            }
         }
    }
    abs=N_NEUTRONS-trav-ref;
    printf("%d neutrons en total\n", N_NEUTRONS);
    printf("Han passat %d neutrons, %f%%\n",trav,
		float(trav)*100/N_NEUTRONS);
    printf("Han rebotat %d neutrons, %f%%\n",ref,
		float(ref)*100/N_NEUTRONS);
    printf("Han estat absorbits %d neutrons,%f%%\n",abs,
		float(abs)*100/N_NEUTRONS);
}
