//m7p08.cpp: Funci mitjana

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include <stdio.h>
#include <stdarg.h>

double mitjana(int n, ...);


void main(){


    printf("mitjana(1) =%f\n",mitjana(1,1.));
    printf("mitjana(1,2) =%f\n",mitjana(2,1.,2.));
    printf("mitjana(1,2,3) =%f\n",mitjana(3,1.,2.,3.));
}




double mitjana(int n, ...){

    int ct;
    double mitja=0.;
    va_list p;

    va_start(p,n);

    for(ct=0;ct<n;ct++){
        mitja=mitja+va_arg(p, double);
    }

    va_end(p);
    return mitja/n;
}

