//m8p09.cpp: DUMP


/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/


#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#define MIDA 128

unsigned char buf[MIDA];
void mostrar(int);

void main (int argc, char *argv[]){
    FILE *fp;
    int sector, n;
    if (argc!=2){
        printf("nombre de parmetres incorrecte\n");
        exit(1);
    }

    if((fp=fopen(argv[1], "rb"))==NULL){
        printf("no es pot obrir l'arxiu\n");
        exit(1);
    }

    do{
        printf("introduu el sector: ");
        scanf("%d", &sector);
        if(fseek(fp, sector*MIDA, SEEK_SET)){
            printf("error de fseek\n");
        }
        if((n=fread(buf, 1, MIDA, fp)) !=MIDA){
            printf("trobat EOF\n");
        }

        mostrar(n);
    }while(sector>=0);
}

void mostrar(int n){
   int i,j;
   for(i=0;i<n/16; i++){
     for(j=0;j<16;j++) printf("%3X", buf[i*16+j]);printf(" ");
     for(j=0;j<16;j++) {
        if (isprint(buf[i*16+j])) printf("%c", buf[i*16+j]);
        else printf(".");
     }
     printf("\n");
   }
}