//m2p02.cpp: La mida de les variables

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include <stdio.h>
#include <limits.h>
#include <float.h>

void main(){

  //mida de les variables
  printf("mida del tipus char       : %d\n",sizeof(char));
  printf("mida del tipus short int  : %d\n",sizeof(short));
  printf("mida del tipus int        : %d\n",sizeof(int));
  printf("mida del tipus long int   : %d\n",sizeof(long));
  printf("mida del tipus float      : %d\n",sizeof(float));
  printf("mida del tipus double     : %d\n",sizeof(double));
  printf("mida del tipus long double: %d\n",sizeof(long double));
  printf("mida del tipus bool       : %d\n",sizeof(bool));

  printf("\n");
  
  // lmits
  printf("mnim i mxim de char    : %d %d\n",CHAR_MIN, CHAR_MAX);
  printf("mxim d'unsigned char    : %u\n",UCHAR_MAX);
  printf("mnim i mxim de short   : %d %d\n",SHRT_MIN, SHRT_MAX);
  printf("mxim d'unsigned short   : %u\n",USHRT_MAX);
  printf("mnim i mxim d'int      : %d %d\n",INT_MIN, INT_MAX);
  printf("mxim d'unsigned int     : %u \n",UINT_MAX);
  printf("mnim i mxim de float   : %g %g\n",FLT_MIN, FLT_MAX);
  printf("mnim i mxim de double  : %g %g\n",DBL_MIN, DBL_MAX);
  printf("\n");
  
  //mida d'expressions
  char c=0;
  int i=0;
  float f=0;
  double d=0;

  printf("mida de l'expressi c+i : %d\n", sizeof(c+i));
  printf("mida de l'expressi i+f : %d\n", sizeof(i+f));
  printf("mida de l'expressi i+d : %d\n", sizeof(i+d));
  printf("mida de l'expressi f+d : %d\n", sizeof(f+d));
}
