//m3pa12.c - Mètode de Newton -

#include <stdio.h>
#include <math.h>
#define MAX_ITER 20

double newton(double, double);
double f (double);
double df (double);

int main(){

    double x0,error;

    printf("introduïu x0 i error...");
    scanf("%lf %lf",&x0, &error);
    printf("\nLa solució és %lf\n",newton(x0,error));
    return 0;
}


double newton(double x0,double error){

    int iter=0;
    double x;

    x=x0;
    do{
       x0=x;
       x=x0-f(x0)/df(x0);
       printf("%lf %lf\n",x,x-x0);
    }while(fabs(x-x0)>error&&iter++<MAX_ITER);

    return x;
}

double f(double x){           //definició de f(x) 
     return exp(x)-x*x;
}

double df(double x){         //definició de f'(x)
    return exp(x)-2*x;
}
