//m3pa12.cpp: Mtode de Newton

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include <stdio.h>
#include <math.h>
#define MAX_ITER 20

double newton(double, double);
double f (double);
double df (double);

void main(){

    double x0,error;

    printf("introduu x0 i error...");
    scanf("%lf %lf",&x0, &error);
    printf("\nLa soluci s %lf\n",newton(x0,error));

}


double newton(double x0,double error){
    int iter=0;
    double x;

    x=x0;
    do{
       x0=x;
       x=x0-f(x0)/df(x0);
       printf("%lf %lf\n",x,x-x0);
    }while(fabs(x-x0)>error&&iter++<MAX_ITER);
    return x;
}

double f(double x){           //definici de f(x)
     return exp(x)-x*x;
}

double df(double x){         //definici de f'(x)
    return exp(x)-2*x;
}
