//m6pa1.c  - Sopa de lletres  -

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


void introduccio_dades(void);
void hor_dre(char *);
void hor_esq(char *);
void ver_bai(char paraula[]);
void ver_dal(char paraula[]);
void mostrar_tauler();
void inicialitzar_tauler();

char tauler[11][11];
unsigned dimensio;

int main (){
    char paraula[11];

    introduccio_dades();
    do{
        printf("Introduu la paraula a buscar\n");
        printf("(premeu 0+INTRO per acabar)...");
        scanf(" %s",paraula);
        printf("\n\n");
        system("clear"); 
        hor_dre(paraula);
        hor_esq(paraula);
        ver_bai(paraula);
        ver_dal(paraula);

        mostrar_tauler();
        inicialitzar_tauler();
    }while(*paraula!='0');
	return 0;
}


void hor_dre(char paraula[]){
    unsigned i,j;
    char text[10];
    char *punter;

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++) text[j]=tauler[i][j];

        if(!(punter=strstr(text, paraula))) continue;

        for (j=0;j<strlen(paraula);j++)
             punter[j]=toupper(punter[j]);

        for(j=0;j<dimensio;j++) tauler[i][j]=text[j];

        printf("\nEs troba a la fila horitzontal dreta %d\n",i);
        return;

    }
}


void hor_esq(char paraula[]){
    unsigned i,j;
    char text[10];
    char *punter;

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++)
             text[dimensio-j-1]=tauler[i][j];

        if(!(punter=strstr(text, paraula))) continue;

        for (j=0;j<strlen(paraula);j++)
              punter[j]=toupper(punter[j]);

        for(j=0;j<dimensio;j++)
                           tauler[i][j]=text[dimensio-j-1];
        printf("\nEs troba a la fila horitzontal esquerra %d\n",i);
        return;

    }
}


void ver_bai(char paraula[]){
    unsigned i,j;
    char text[10];
    char *punter;

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++) 
             text[j]=tauler[j][i];

        if(!(punter=strstr(text, paraula))) continue;

        for (j=0;j<strlen(paraula);j++)
              punter[j]=toupper(punter[j]);

        for(j=0;j<dimensio;j++)
              tauler[j][i]=text[j];

        printf("\nEs troba a la fila vertical cap a baix %d\n",i);
        return;

     }
}



void ver_dal(char paraula[]){
    unsigned i,j;
    char text[10];
    char *punter;

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++)
             text[j]=tauler[dimensio-j-1][i];

        if(!(punter=strstr(text, paraula))) continue;

        for (j=0;j<strlen(paraula);j++)
              punter[j]=toupper(punter[j]);

        for(j=0;j<dimensio;j++)
              tauler[dimensio-j-1][i]=text[j];

        printf("\nEs troba a la fila vertical cap a dalt %d\n",i);
        return;

    }
}


void introduccio_dades(void){
    unsigned i;
   
    printf("Introduu la dimensi de la sopa de lletres\n");
    scanf(" %d",&dimensio);
    printf("Introduu el tauler per files\n");
    for (i=0;i<dimensio;i++) scanf(" %s",tauler[i]);

}


void inicialitzar_tauler(){
    unsigned i,j; 

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++){
            tauler[i][j]=tolower(tauler[i][j]);
        }
    }

}



void mostrar_tauler(){
    unsigned i,j; 

    for(i=0;i<dimensio;i++){
        for(j=0;j<dimensio;j++){
             printf("%c",tauler[i][j]);
        }
        printf("\n");

    }
}
