//m7p01.cpp: Miniagenda telefnica

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<conio.h>


#define MAX 100

struct {
    char nom[30];
    char cognom1[30];
    char cognom2[30];
    char tel[9];
} entrada[MAX];

int punter=0;

void nova_entrada(void);
void esborra_entrada(void);
void mostrar(void);
void cerca_nom(void);
void cerca_cognom1(void);
void cerca_tel(void);


void main(){
    char sel;

    do{
        system("cls");
        printf("Miniagenda telefnica\n\n\n");
        printf("1. Introduir nova entrada\n");
        printf("2. Esborrar entrada\n");
        printf("3. Cerca per nom\n");
        printf("4. Cerca per cognom1\n");
        printf("5. Cerca per telfon\n");
        printf("6. Mostra totes les entrades\n");
        printf("7. Sortir\n\n\n");
        printf("\n\n Premi una opci (ESC per sortir)\n");

        do{
            sel=getchar();
        }while((sel<'1' || sel>'7')&&sel!=27);

        switch(sel){
            case '1':
                nova_entrada();
                break;

            case '2':
                esborra_entrada();
                break;

            case '3':
                cerca_nom();
                break;

            case '4':
                cerca_cognom1();
                break;

            case '5':
                cerca_tel();
                break;

            case '6':
                mostrar();
                break;

            case '7':
            case 27:
                return;
         };
    }while(1);
}




void nova_entrada(void){

    if (punter==MAX) {
        printf("no s possible afegir ms entrades");
        getch();
        return;
    }


    printf("entrada %d.\n",punter);
	rewind(stdin);          //esborra el bfer d'entrada
    printf("\nnom? ");gets(entrada[punter].nom);
    printf("cognom1? ");gets(entrada[punter].cognom1);
    printf("cognom2? ");gets(entrada[punter].cognom2);
    printf("telfon? ");gets(entrada[punter].tel);
    printf("\nEntrada %d emmagatzemada", punter);
    punter++;
    return;
}






void esborra_entrada(void){
    int sel,ct;
    printf("nmero d'entrada per esborrar?\n");
    getchar();
    scanf("%d",&sel);

    if (sel<0||sel>=punter){
        printf("nmero d'entrada erroni");
        getch();
        return;
    }

    for (ct=sel+1;ct<punter;ct++){
        entrada[ct-1]=entrada[ct];
    }
    punter--;
}




void mostrar(void){
    int ct;
    for (ct=0;ct<punter;ct++){
        printf("%d: %s %s %s %s\n", ct, entrada[ct].nom,
        entrada[ct].cognom1, entrada[ct].cognom2,
        entrada[ct].tel);
    }
    getch();
    return;
}




void cerca_nom(void){
    int ntrobats=0,ct;
    char ncer[30];

    printf("nom a buscar?\n");
    scanf(" %s", ncer);

    for(ct=0;ct<punter;ct++){
      if( !strncmp( ncer, entrada[ct].nom, strlen(ncer))){
         printf("%d: %s %s %s %s\n",
			 ct, entrada[ct].nom,entrada[ct].cognom1, entrada[ct].cognom2,entrada[ct].tel);
         ntrobats++;
      }
    }
    printf("s'han trobat %d entrades",ntrobats);
    getch();
    return;
}




void cerca_cognom1(void){
    int ntrobats=0,ct;
    char ncer[30];

    printf("cognom1 a buscar?\n");
    scanf(" %s", ncer);

    for(ct=0;ct<punter;ct++){
      if( !strncmp( ncer, entrada[ct].cognom1, strlen(ncer))){
			printf("%d: %s %s %s %s\n",
			 ct, entrada[ct].nom,entrada[ct].cognom1, entrada[ct].cognom2,entrada[ct].tel);
         ntrobats++;
      }
    }
    printf("s'han trobat %d entrades",ntrobats);
    getch();
    return;
}




void cerca_tel(void){
    int ntrobats=0,ct;
    char ncer[30];

    printf("telfon a buscar?\n");
    scanf(" %s", ncer);

    for(ct=0;ct<punter;ct++){
      if( !strncmp( ncer, entrada[ct].tel,strlen(ncer))){
         printf("%d: %s %s %s %s\n",
			 ct, entrada[ct].nom,entrada[ct].cognom1, entrada[ct].cognom2,entrada[ct].tel);
         ntrobats++;
      }
    }
    printf("s'han trobat %d entrades",ntrobats);
    getch();
    return;
}


