//m8pa1.cpp. Cerca dicotmica

/*********************************************
* Fonaments de Programaci. Llenguatge C/C++ *
* (c) Francisco J. Ruiz. 2001                *
*********************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>



struct fitxa{
    int codi;
    char nom[20];
    char cognoms[20];
    float nota;
};

fitxa cerca(FILE *fp, int n_reg, int codi);



void main(){
    FILE *fp;
    fitxa alumne;
    int codi;
	int n_reg;
    char arxiu[12];
    struct _stat buf;

    printf("Introduu el nom de l'arxiu de dades\n");
    scanf("%s",arxiu);

    if((fp=fopen(arxiu, "r"))==NULL){
        printf("Error al intentar obrir l'arxiu\n");
        return;
    }

    if(_stat( arxiu, &buf )!=0 ){
        printf( "Error de la funci _stat\n" );
        return;
    }

    n_reg=buf.st_size/sizeof(alumne);

    printf("Introduu el codi d'alumne a buscar..");
    scanf("%d", &codi);



    alumne=cerca(fp,n_reg,codi);

    if(alumne.codi!=-1)
         printf("%d %s %s %f", alumne.codi, alumne.nom,
                alumne.cognoms, alumne.nota);
    else
         printf("no es troba el registre sollicitat\n");
    fclose(fp);

}



fitxa cerca(FILE *fp, int n_reg, int codi){


    int primer, ultim, tall,final=0;
    fitxa alumne;

    primer=1;
    ultim=n_reg;

    while(1){
        tall=(primer+ultim)/2;
        fseek(fp,(tall-1)*sizeof(alumne),SEEK_SET);
        fread(&alumne, sizeof(alumne),1,fp);
        if(codi<alumne.codi)
           ultim=tall-1;
        else{
            if(codi>alumne.codi) primer=tall+1;
            else return alumne;
        }
        if(primer>ultim){
            alumne.codi=-1;
            return alumne;
        }
    }

}

