//m8pa12.cc - llegir i escriure resgistre
#include <stdio.h>

// prototipus de les funcions
void lectura_tot_arxiu();

typedef struct {
   char nom[20];
   int edat;
} persona;

FILE *f1;
	persona dada;

int main()
{
	int nombreRegistres;


	// Obriem l'arxiu per lectura i escriptura
	f1 = fopen ("alumnes.dat", "rb+");
	if (f1 == NULL)
	{
   		perror("No es pot obrir alumnes.dat");
   		return -1;
	}
	
	//Obtenim el total de resgistres que hi ha en el fitxer
	fseek(f1, 0, SEEK_END);
	nombreRegistres = ftell(f1)/sizeof(dada);
	printf ("\n Dins el fitxer hi ha %d resgistres \n",nombreRegistres);

	// Portem el cursor al cinquè registre, index 4
	fseek (f1, 4*sizeof(dada), SEEK_SET);

	// Mostrem la informació
	fread (&dada, sizeof(dada), 1, f1);
	printf ("nom = %s\n", dada.nom);
	printf ("edat = %d\n", dada.edat);


	//Modifiquem les dades de l'estructura
	printf("\n Introduïr un nou nom ");	
	scanf("%s",dada.nom);
	printf("\n Introduïr la nova edat ");
	scanf("%d",&dada.edat);

	// Ens situem a l'inici del registre 5
	fseek(f1, 4*sizeof(dada), SEEK_SET);

	// escribim damunt
	fwrite (&dada, sizeof(dada), 1, f1);
	fclose(f1);
	
	//lectura de tot l'arxiu per comprovar els canvis
	lectura_tot_arxiu();

	return 0;
}

void lectura_tot_arxiu()
{
	f1 = fopen ("alumnes.dat", "rb+");
	if (f1 == NULL)
	{
   		perror("No es pot obrir alumnes.dat");
   		return;
	}
	while(fread (&dada, sizeof(dada), 1, f1))
		printf("\n nom %s edat %d",dada.nom, dada.edat);
		
}
